首页 > 其他分享 >牛客周赛 Round 31

牛客周赛 Round 31

时间:2024-02-05 22:00:12浏览次数:28  
标签:int 31 long 牛客 solve pair using Round define

牛客周赛 Round 31

小红小紫替换

代码:

#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define fi first
#define se second
using i128 = __int128_t;
using piii = pair<ll, pair<ll, ll>>;

void solve()
{
    string s;
    cin >> s;
    if (s == "kou")
    {
        cout << "yukari" << endl;
    }
    else
    {
        cout << s << endl;
    }
}

int main()
{

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}

小红的因子数

代码:

#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define fi first
#define se second
using i128 = __int128_t;
using piii = pair<ll, pair<ll, ll>>;

void solve()
{
    ll x;
    cin >> x;
    int cnt = 0;
    for (int i = 2; i <= x / i; i++)
    {
        if (x % i == 0)
        {
            cnt++;
            while (x % i == 0)
            {
                x /= i;
            }
        }
    }
    if (x > 1)
    {
        cnt++;
    }
    cout << cnt << endl;
}

int main()
{

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}

小红的字符串中值

解题思路:

对于每一个询问字符,考虑以它为中心能构造多少子串,即尽量往两边扩。

代码:

#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define fi first
#define se second
using i128 = __int128_t;
using piii = pair<ll, pair<ll, ll>>;

void solve()
{
    int n;
    char c;
    scanf("%d %c", &n, &c);
    string s;
    cin >> s;
    ll ans = 0;
    for (int i = 0; i < n; i++)
    {
        if (s[i] == c)
        {
            int l = i - 0;
            int r = n - 1 - i;
            ans += min(l, r) + 1;
        }
    }
    cout << ans << endl;
}

int main()
{

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}

小红数组操作

解题思路:

用\(map\)模拟链表操作。

代码:

#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define fi first
#define se second
using i128 = __int128_t;
using piii = pair<ll, pair<ll, ll>>;
const int N = 2e5 + 10;
map<ll, int> l, r;

void solve()
{
    int q;
    cin >> q;
    map<int, int> v;
    int h = 0;
    int cnt = 0;
    while (q--)
    {
        int t;
        cin >> t;
        if (t == 1)
        {
            int x, y;
            cin >> x >> y;
            cnt++;
            if (y == 0)
            {
                r[x] = h;
                l[h] = x;
                h = x;
            }
            else
            {
                l[x] = y;
                r[x] = r[y];
                r[y] = x;
                l[r[x]] = x;
            }
        }
        else
        {
            int x;
            cin >> x;
            r[l[x]] = r[x];
            l[r[x]] = l[x];
            if (x == h)
            {
                h = r[x];
            }
            cnt--;
        }
    }
    // if (cnt == 0)
    // {
    //     cout << 0 << endl;
    //     return;
    // }
    vector<int> ans;
    while (h)
    {
        ans.push_back(h);
        h = r[h];
    }
    cout << ans.size() << endl;
    for (auto c : ans)
    {
        cout << c << ' ';
    }
}

int main()
{

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}

小红的子集取反

解题思路:

\(dp[i][j]:表示取完前i个数字后,此时总和为j的最小取反数。对于第i个数字我们如果减去就是取反,加上就无需增加操作数。\)

注意值域存在负数,所以我们对初始状态进行偏移。

代码:

#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define fi first
#define se second
using i128 = __int128_t;
using piii = pair<ll, pair<ll, ll>>;
const int N = 40000;
const int inf = 1 << 30;
int dp[210][2 * N + 10];

void solve()
{
    int n;
    cin >> n;
    memset(dp, 0x3f, sizeof dp);
    dp[0][40000] = 0;
    for (int i = 1; i <= n; i++)
    {
        int x;
        cin >> x;
        for (int j = 0; j <= 2 * N; j++)
        {
            if (j + x <= 2 * N)
            {
                dp[i][j] = min(dp[i][j], dp[i - 1][j + x] + 1);
            }
            if (j - x >= 0)
            {
                dp[i][j] = min(dp[i][j], dp[i - 1][j - x]);
            }
        }
    }
    if (dp[n][N] > n)
    {
        dp[n][N] = -1;
    }
    cout << dp[n][N] << endl;
}

int main()
{

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}

小红的连续段

解题思路:

字符总长度总是为\(x + y\)。

我们枚举连续段数量,发现只有两种情况:

  • \((a,b,a,b,..)\),即\(a\)连续段开头,此时\(a\)段的数量必定为\(\lceil\frac{i}{2}\rceil\)
  • \((b,a,b,a,...)\),即\(b\)连续段开头,此时\(b\)段的数量必定为\(\lceil\frac{i}{2}\rceil\)

我们设\(a\)段数量为\(cnta\),\(b\)段数量为\(cntb\)。

将\(x\)个\(a\)分为\(cnta\)个非空集合的方案数为\(\binom{x - 1}{cnta - 1}\)

对\(b\)同理。

代码:

#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define fi first
#define se second
using i128 = __int128_t;
using piii = pair<ll, pair<ll, ll>>;
const int N = 1010;
const int mod = 1e9 + 7;
ll c[N][N];
void solve()
{
    int x, y;
    cin >> x >> y;
    int n = x + y;
    c[0][0] = 1;
    for (int i = 1; i <= 1001; i++)
    {
        for (int j = 0; j <= i; j++)
        {
            if (j == 0)
            {
                c[i][j] = 1;
            }
            else
            {
                c[i][j] = (c[i - 1][j] + c[i - 1][j - 1]) % mod;
            }
        }
    }
    for (int i = 1; i <= n; i++)
    {
        ll ans = 0;
        int ca = i / 2;
        int cb = i - ca;
        if (i < 2)
        {
            cout << 0 << endl;
            continue;
        }
        ll res = 1;
        if (ca <= x)
        {
            res = res * c[x - 1][ca - 1] % mod;
        }
        else
        {
            res = 0;
        }
        if (cb <= y)
        {
            res = res * c[y - 1][cb - 1] % mod;
        }
        else
        {
            res = 0;
        }
        ans += res;
        ans %= mod;
        res = 1;
        swap(ca, cb);
        if (ca <= x)
        {
            res = res * c[x - 1][ca - 1] % mod;
        }
        else
        {
            res = 0;
        }
        if (cb <= y)
        {
            res = res * c[y - 1][cb - 1] % mod;
        }
        else
        {
            res = 0;
        }
        ans += res;
        ans %= mod;
        cout << ans << endl;
    }
}

int main()
{

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}

标签:int,31,long,牛客,solve,pair,using,Round,define
From: https://www.cnblogs.com/value0/p/18008899

相关文章

  • 牛客比赛2.5
    比赛链接9题,就看结果来说还是不错的,但是过程我是很不满意的。。A,B签到题,没什么说的必要。C题,数据结构题,很烦,trie树带查询,码起来有些麻烦,考试的时候没有开。其实思路很简单,用01trie树,对每一个点,查找比他小的和它异或起来最大的数字,这个东西在trie树上就是一个贪心,O(logn)级别......
  • 寒假训练第3周(牛客冬训营)
    F-TokitsukazeandEliminate(hard)_2024牛客寒假算法基础集训营2(nowcoder.com)脑袋堵住了,红温没有写出来,后面想到思路直接给否定了,可惜题解:需要你找最右边第一个,直接先统计一下有多少个颜色的宝石,然后从左往右依次放入set到相应的颜色数就加答案,然后如果这种颜色宝石没有了......
  • P10125 「Daily OI Round 3」Simple 题解
    题目传送门简单模拟,主要考察字符串。首先输入一个char类型的数组,然后直接遍历每一位是否为Acoipp或Svpoll即可。//Simple//codeby:cq_irritater//time:2024/02/04#include<bits/stdc++.h>usingnamespacestd;chara[10];intmain(){//freopen("c......
  • 2024牛客寒假算法基础集训营2(小白)
    A.TokitsukazeandBraceletCode:#include<bits/stdc++.h>usingnamespacestd;intmain(){intt;cin>>t;while(t--){inta,b,c,cnt=0;cin>>a>>b>>c;if(a>=150)cnt++;if(a>=200)......
  • 【2024潇湘夜雨】WIN11_Pro_23H2.22635.3139软件选装纯净版2.04
    【系统简介】=============================================================1.本次更新母盘来自WIN11_Pro_23H2.22635.3139.2.增加部分优化方案,手工精简部分较多。3.OS版本号为22635.3139。精简系统只是为部分用户安装,个别要求高的去MSDN下。4.集成《DrvCeo-2.16.0.0》网卡版、运......
  • 2024牛客寒假算法基础集训营2
    题目链接A.模拟#include<bits/stdc++.h>usingnamespacestd;#defineintlonglongconstintN=1e5+10;voidsolve(){intn;cin>>n;while(n--){inta,b,c;cin>>a>>b>>c;intans=0;if(a==150)ans+=1......
  • 牛客周赛31
    A小红小紫替换https://ac.nowcoder.com/acm/contest/74362/A这题相当于签到题只需要将kou的情况转换成yukari就行其他不变点击查看代码#include<bits/stdc++.h>usingnamespacestd;intmain(){stringa;cin>>a;if(a=="kou")cout<<"yukari"......
  • 牛客周赛 Round 31(A~F)
    目录ABCDEFA#include<bits/stdc++.h>#defineintlonglong#definerep(i,a,b)for(inti=(a);i<=(b);++i)#definefep(i,a,b)for(inti=(a);i>=(b);--i)#definepiipair<int,int>#definepllpair<longlong,longlong>#de......
  • 牛客周赛 Round 31(很菜的小白)
    A.小红小紫替换思路:签到题,字符串如果是kou就替换成yukari取余不变解法:无Code:#include<bits/stdc++.h>usingnamespacestd;intmain(){strings;std::cin>>s;std::cout<<(s=="kou"?"yukari\n":s)<<'\n&#......
  • 2024牛客寒假算法基础集训营1 J 又鸟之亦心 题解
    Question2024牛客寒假算法基础集训营1J又鸟之亦心Solution挺好的一个题,给了我很多启发显然,先二分最大值\(D\),关键在于\(check\)怎么写考虑到两个人是相对的,第\(i\)次之后肯定有一个人在\(a_i\),具体是谁不重要,也不需要关注是怎么走过来的,我们需要去维护另外一个人可......